unit TermInterpreter;

interface

var LastErrorMsg : String;
    LastErrorPos : Integer;
    Okay         : Boolean;

function TermWert(s: String): Double;


implementation

uses math;

{ Interne Hilfsfunktionen }

function GetFirstChar(var s: String): Char;
  begin
  While (Length(s) > 0) and (s[1] in [' ']) do
    Delete(s, 1, 1);             { killt fhrende Leerzeichen        }
  If Length(s) > 0 then
    Result := s[1]               { gibt das erste Zeichen zurck.... }
  else
    Result := #0;                { ... oder bei leerem String ein #0 }
  end;

{ Scannerfunktionen fr logische Term-Bestandteile }

function N_Zahl(var s: String; var res: Double): Boolean;
  var c : Char;
  begin
  c := GetFirstChar(s);
  If c in ['0'..'9'] then begin  { Es wird eine Ziffer erwartet....    }
    Result := True;
    res := 0;
    Repeat                       { Solange Ziffern da sind, werden sie }
      Delete(s, 1, 1);
      res := 10 * res + (Ord(c) - Ord('0'));  { ... ausgewertet.       }
      c := GetFirstChar(s);                   { Nchstes Zeichen holen }
    until not (c in ['0'..'9']); { bis keine Ziffer mehr gefunden wird }
    end
  else begin                     { Falls keine Ziffer da ist: Fehler!  }
    Result := False;
    LastErrorMsg := 'Ziffer erwartet!';       { Fehlermeldung absetzen }
    end;
  end;

{ Interface-Funktion }

function TermWert(s: String): Double;
  var r   : Double;
      ils : Integer;
  begin
  LastErrorMsg := '';
  LastErrorPos := 0;
  ils := Length(s);
  IF N_Zahl(s, r) then begin
    Result := r;
    Okay   := True;
    end
  else begin
    Result := 0;
    Okay := False;
    LastErrorPos := ils - Length(s);
    LastErrorMsg := LastErrorMsg + '  {Rest : ' + s + ' }';
    end;
  end;

end.
